LeetCode——1. Two Sum

嘿嘿,这是我的第一篇博客,希望大家能够多多支持,多多指教。
这道题是LeetCode上的第一道题,问题描述是这样的:
Given an array of integers, return indices of the two numbers such that they add up to a specific target.
You may assume that each input would have exactly one solution, and you may not use the same element twice.

Example:
Given nums = [2, 7, 11, 15], target = 9,

Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].

说白了,就是在数组中找出两个能够相加能够等于目标数的数,并将这两个数在数组中的索引保存到一个result数组中。

思路如下:
最简单的方法就是直接暴力尝试,时间复杂度是O(n^2),这里就不说了。
有一种比较巧妙的思路。它是利用哈希的想法。
大家都知道使用哈希的优点就是能够快速查找,正好这道题也需要查找,使用哈希不就能够提高效率了吗?
创建一个map,用来保存值与它在数组中的索引。
然后遍历数组,如果能够在map中寻找到与当前元素求和满足要求的数,则直接将当前数的索引以及map中键对应的索引放入到数组中;否则就将其存入map。
这里的算法,快就快在map中搜索值是常数级别的复杂度,因此这个方法的复杂度为O(n),即遍历一次数组的复杂度。

public class Solution {
    public int[] twoSum(int[] nums, int target) {
        int []result = new int[2];
        Map map = new HashMap();
        for(int i = 0; i < nums.length; i++){
            if(map.containsKey(target - nums[i])){
                result[0] = map.get(target - nums[i]);
                result[1] = i;
                return result;
            }
            map.put(nums[i], i);
        }
        return result;
    }
}

你可能感兴趣的:(leetcode,leetcode,博客)